WindowPanel = function(config){
  //ı
  this.id = config.id;

  //ı
  this.title = config.title || '';

  //ı
  this.renderTo = config.renderTo || $(document.body);

  //ݵĿ
  this.width = config.width || 400;

  //ݵĸ߶
  this.height = config.height || 300;
  
  //
  this.html = config.html;

  //
  this.render = typeof this.renderTo == 'string' ? $('#'+this.renderTo) : this.renderTo;

  //Ƿ϶
  this.dragable = config.dragable || false;

  //ʵ
  this.toolbar = config.toolbar || undefined;

  //WindowPanleǷӹ
  this.hasToolbar = config.hasToolbar || false;

  //ʼ
  if($('#'+this.id).length==0)
    this.init();
};

WindowPanel.prototype = {

  //μȾ
  init : function(){

    var windowEntity = this;

    this.windowBack = $('<DIV></DIV>');
    this.windowBack.attr('id', 'WindowPanel_Back');
    this.windowBack.addClass('window_back');
    this.windowBack.css('width', this.renderTo.width());
    this.windowBack.css('height', this.renderTo.height());
    this.windowBack.appendTo(this.renderTo);

    //ʵĳز
    this.windowpanel = $('<DIV></DIV>');
    this.windowpanel.attr('id',this.id);
    this.windowpanel.addClass('windowpanel');
    this.windowpanel.css('z-index',this.getActive()+1);
    this.windowpanel.appendTo(this.render);
    
    //ʵı
    this.windowpanel_title = $('<DIV></DIV>');
    this.windowpanel_title.addClass('windowpanel_title');
    this.windowpanel_title.text(this.title);
    this.windowpanel_title.appendTo(this.windowpanel);
    
    //ʵݲ
    this.windowpanel_content = $('<DIV></DIV>');
    this.windowpanel_content.addClass('windowpanel_content');
    this.windowpanel_content.css('height',this.height);
    this.windowpanel_content.appendTo(this.windowpanel);
     //ʵĹ߲
    this.windowpanel_toolbar = $('<DIV></DIV>');
    this.windowpanel_toolbar.addClass('windowpanel_toolbar');
    this.windowpanel_toolbar.appendTo(this.windowpanel);   
    //ʵĹرհť
    this.closer = $('<DIV></DIV>');
    this.closer.addClass('closer');
    this.closer.appendTo(this.windowpanel_title);

    //ȡݲⲹ
    var marginWidth = parseInt(this.windowpanel_content.css('marginLeft') + this.windowpanel_content.css('marginRight'));

    //ȡݲⲹ
    var marginHeight = parseInt(this.windowpanel_content.css('marginTop') + this.windowpanel_toolbar.css('marginBottom'));

    //ĿȺ͸߶
    this.windowpanel.css({
      'width' : this.width+marginWidth,
      'height' : this.height+marginHeight+this.windowpanel_title.height()+6
    });

    //Ϊonclick¼
    this.windowpanel.click(function(){

      //ȡǰ
      var position = windowEntity.render.find('.windowpanel').index(windowEntity.windowpanel[0]);

      //󶨼¼
      windowEntity.setActive(position);
    });

    //Ϊ󶨹ر¼
    this.closer.click(function(){
      var position = windowEntity.render.find('.windowpanel').index(windowEntity.windowpanel[0]);
      windowEntity.kill(position);
    });

    //dragableΪtrueƶ
    if(this.dragable){
      this.windowpanel.draggable({ containment: 'parent' });
      this.windowpanel_title.addClass('windowpanel_move');
      this.windowpanel_title.hover(
        function(){
          windowEntity.windowpanel.draggableEnable();
        },
        function(){
          windowEntity.windowpanel.draggableDisable();
        }
      );
    }
    
    this.windowpanel_content.html(this.html);
    
    //ӹ
    this.addToolbar(this.toolbar);
    
    //ʹоʾ
    this.top = parseInt(this.render.get(0).clientHeight / 2) - 
      parseInt(this.windowpanel.get(0).clientHeight / 2);
    this.left = parseInt(this.render.get(0).offsetWidth / 2) - 
      parseInt(this.windowpanel.get(0).offsetWidth / 2);
    this.windowpanel.css({'top':this.top+'px','left':this.left+'px'});
    
  },

  //Ϊposition壬ʹʾϲ
  //@position : Ѿ弯ϵ
  setActive : function(position){

    //ȡָz-index
    var own_z_index = parseInt(this.render.find('.windowpanel').eq(position).css('z-index'));

    //ȡ弯ϵz-index
    var max_z_index = this.getActive();
    
    //ѡеz-indexСֵѡz-indexóֵ
    if(own_z_index < max_z_index)
      this.render.find('.windowpanel').eq(position).css('z-index',max_z_index+1);
  },

  //õǰ
  getActive : function(){

    //Ĭϵz-index
    var max_z_index = 100001;

    //Ѿҳz-indexֵ
    this.render.find('.windowpanel').each(function(i){
      var zIndex = parseInt($(this).css('z-index'));
      if(zIndex > max_z_index){
        max_z_index = zIndex;
      }
    });

    return max_z_index;
  },

  //رΪposition
  //@position : Ѿ弯ϵ
  kill : function(position){
    var windowPanelEntity = this;
    this.render.find('.windowpanel').eq(position).fadeOut(200, function(){
      windowPanelEntity.windowBack.remove();
      windowPanelEntity.render.find('.windowpanel').eq(position).remove();
    });
  },

  //ʾΪposition
  //@position : Ѿ弯ϵ
  show : function(position){
    if(this.render.find('.windowpanel').eq(position).is(':hidden'))
      this.render.find('.windowpanel').eq(position).show();
  },

  //Ϊposition
  //@position : Ѿ弯ϵ
  close : function(position){
    if(this.render.find('.windowpanel').eq(position).is(':visible'))
      this.render.find('.windowpanel').eq(position).hide();
  },

  //ӹ
  //@toolbar : ʵ
  addToolbar : function(toolbar){
    //ûӹҴĹΪ,ӹ
    if(!this.hasToolbar && toolbar){

      toolbar.renderContent = this.windowpanel_toolbar;
      toolbar.render();
      this.toolbar = toolbar;
      
      //ùĸ߶
      this.windowpanel.height(this.windowpanel.height() + this.windowpanel_toolbar.height());
    }
    //ĹΪգ׷ӹϢ
    else if(toolbar)
    {
      for(var i = 0 ; i < toolbar.items.length ; i++){
        this.toolbar.add(toolbar.items[i]);
      }
    }
  },

  //ɾ
  removeToolBar : function(){

    //ӹѾ˹Ѿ˹չ
    if(this.hasToolbar && this.toolbar && this.windowpanel_toolbar){

      //ĸ߶
      this.windowpanel.height(this.windowpanel.height() - this.windowpanel_toolbar.height());

      //ݣǱ
      this.windowpanel_toolbar.empty();

      //Ĺ
      this.toolbar = null;
    }
  }
};

//ID
WindowPanel.hideById = function(id){
  $('#WindowPanel_Back').fadeOut(200);
  $('#'+id).fadeOut(200);
};
//IDر
WindowPanel.killById = function(id){
  $('#WindowPanel_Back').remove();
  $('#'+id).remove();
};